﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using C1.WPF.C1Chart;
using C1.WPF.C1Chart.Extended;

namespace ChartInTabs
{
  /// <summary>
  /// Interaction logic for MainWindow.xaml
  /// </summary>
  public partial class MainWindow : Window
  {
    int cnt = 10;
    int npts = 100;
    Random rnd = new Random();
    C1Chart[] charts;
    
    public MainWindow()
    {
      InitializeComponent();

      charts = new C1Chart[cnt];
      // create tabs with charts
      for (int i = 0; i < cnt; i++)
      {
        charts[i] = new C1Chart() {ChartType = ChartType.Line};
        var values1 = new double[npts];
        var values2 = new double[npts];
        var values3 = new double[npts];

        for (int j = 0; j < npts; j++)
        {
            values1[j] = rnd.Next(100);
            values2[j] = rnd.Next(100);
            values3[j] = rnd.Next(100);
        }
        charts[i].Data.Children.Add(new DataSeries() {ValuesSource = values1, Label = "series1" });
        charts[i].Data.Children.Add(new DataSeries() { ValuesSource = values2, Label = "series2" });
        charts[i].Data.Children.Add(new DataSeries() { ValuesSource = values3, Label = "series3" });
        charts[i].Palette = ColorGeneration.Solstice;
        charts[i].Children.Add(new C1ChartLegend() { Title = "Chart " + i });

        tabs.Items.Add(new TabItem() 
          { 
            Header = "Tab " + i,
            Content = new Grid() { Children = { charts[i] } } 
          }
        );
      }
    }

    private void SaveBtn_Click(object sender, RoutedEventArgs e)
    {
        // use size of visible chart
        var sz = new Size(charts[0].ActualWidth, charts[0].ActualHeight);
        for (int i = 0; i < cnt; i++)
        {
        using (var file = File.Open("chart" + i +  ".jpg", FileMode.Create))
        {
            // two arranges is neccesary to perform chart layout
            charts[i].Arrange(new Rect(0, 0, sz.Width, sz.Height));
            charts[i].Arrange(new Rect(0, 0, sz.Width, sz.Height));
            charts[i].UpdateLayout();

            charts[i].SaveImage(file, ImageFormat.Jpeg);
        }
        }
    }

    private void Grid_Loaded(object sender, RoutedEventArgs e)
    {
        Application.Current.Resources.MergedDictionaries.Add(C1.WPF.Theming.C1Theme.GetCurrentThemeResources(new C1.WPF.Theming.ShinyBlue.C1ThemeShinyBlue()));
    }
  }
}
